From: Anna Schumaker <Anna.Schumaker@Netapp.com>
To: fstests@vger.kernel.org
Cc: Anna.Schumaker@Netapp.com, linux-nfs@vger.kernel.org, hch@infradead.org
Subject: [PATCH v6 3/5] generic/431: Add copy test that overwrites data
Date: Wed, 10 May 2017 13:46:26 -0400 [thread overview]
Message-ID: <20170510174628.22895-4-Anna.Schumaker@Netapp.com> (raw)
In-Reply-To: <20170510174628.22895-1-Anna.Schumaker@Netapp.com>
Using copy to overwrite data in the destination file is perfectly valid,
so let's make sure this case works as expected.
Signed-off-by: Anna Schumaker <Anna.Schumaker@Netapp.com>
---
tests/generic/431 | 100 ++++++++++++++++++++++++++++++++++++++++++++++++++
tests/generic/431.out | 17 +++++++++
tests/generic/group | 1 +
3 files changed, 118 insertions(+)
create mode 100755 tests/generic/431
create mode 100644 tests/generic/431.out
diff --git a/tests/generic/431 b/tests/generic/431
new file mode 100755
index 00000000..413aa8d2
--- /dev/null
+++ b/tests/generic/431
@@ -0,0 +1,100 @@
+#!/bin/bash
+# FS QA Test No. 431
+#
+# Tests vfs_copy_file_range():
+# - Copy a file
+# - Use copy to swap data at beginning and end
+# - Use copy to swap data in the middle
+# - Use copy to simultaneously overwrite and append to destination file
+#-----------------------------------------------------------------------
+# Copyright (c) 2017 Netapp, Inc. All rights reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+#-----------------------------------------------------------------------
+#
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -rf $tmp.*
+}
+
+# get standard environment
+. common/rc
+. common/filter
+
+# real QA test starts here
+_supported_fs generic
+_supported_os Linux
+
+_require_xfs_io_command "copy_range"
+_require_test
+
+testdir=$TEST_DIR/test-$seq
+rm -rf $testdir
+mkdir $testdir
+rm -f $seqres.full
+
+echo "Create the original file and then copy"
+$XFS_IO_PROG -f -c 'pwrite -S 0x61 0 1000' $testdir/file >> $seqres.full 2>&1
+$XFS_IO_PROG -f -c 'pwrite -S 0x62 1000 1000' $testdir/file >> $seqres.full 2>&1
+$XFS_IO_PROG -f -c 'pwrite -S 0x63 2000 1000' $testdir/file >> $seqres.full 2>&1
+$XFS_IO_PROG -f -c 'pwrite -S 0x64 3000 1000' $testdir/file >> $seqres.full 2>&1
+$XFS_IO_PROG -f -c 'pwrite -S 0x65 4000 1000' $testdir/file >> $seqres.full 2>&1
+$XFS_IO_PROG -f -c "copy_range $testdir/file" "$testdir/copy"
+cmp $testdir/file $testdir/copy
+echo "Original md5sums:"
+md5sum $testdir/{file,copy} | _filter_test_dir
+
+echo "Swap beginning and end of original file"
+$XFS_IO_PROG -f -c "copy_range -s 4000 -l 1000 $testdir/file" "$testdir/copy" 2>&1
+$XFS_IO_PROG -f -c "copy_range -d 4000 -l 1000 $testdir/file" "$testdir/copy" 2>&1
+cmp -n 1000 $testdir/file $testdir/copy 4000
+cmp -n 3000 $testdir/file $testdir/copy 1000 1000
+cmp -n 1000 $testdir/file $testdir/copy 0 4000
+echo "md5sums after swapping beginning and end:"
+md5sum $testdir/{file,copy} | _filter_test_dir
+
+echo "Swap middle parts of original file"
+$XFS_IO_PROG -f -c "copy_range -s 1000 -d 3000 -l 1000 $testdir/file" "$testdir/copy" 2>&1
+$XFS_IO_PROG -f -c "copy_range -s 3000 -d 1000 -l 1000 $testdir/file" "$testdir/copy" 2>&1
+cmp -n 1000 $testdir/file $testdir/copy 4000
+cmp -n 1000 $testdir/file $testdir/copy 3000 1000
+cmp -n 1000 $testdir/file $testdir/copy 2000 2000
+cmp -n 1000 $testdir/file $testdir/copy 1000 3000
+cmp -n 1000 $testdir/file $testdir/copy 0 4000
+echo "md5sums after swapping middle:"
+md5sum $testdir/{file,copy} | _filter_test_dir
+
+echo "Copy tail of original file onto copy"
+$XFS_IO_PROG -f -c "copy_range -s 1000 -d 3000 -l 4000 $testdir/file" "$testdir/copy" 2>&1
+cmp -n 1000 $testdir/file $testdir/copy 4000
+cmp -n 1000 $testdir/file $testdir/copy 3000 1000
+cmp -n 1000 $testdir/file $testdir/copy 2000 2000
+cmp -n 4000 $testdir/file $testdir/copy 1000 3000
+echo "md5sums after copying tail:"
+md5sum $testdir/{file,copy} | _filter_test_dir
+
+#success, all done
+status=0
+exit
diff --git a/tests/generic/431.out b/tests/generic/431.out
new file mode 100644
index 00000000..175fbdf1
--- /dev/null
+++ b/tests/generic/431.out
@@ -0,0 +1,17 @@
+QA output created by 431
+Create the original file and then copy
+Original md5sums:
+e11fbace556cba26bf0076e74cab90a3 TEST_DIR/test-431/file
+e11fbace556cba26bf0076e74cab90a3 TEST_DIR/test-431/copy
+Swap beginning and end of original file
+md5sums after swapping beginning and end:
+e11fbace556cba26bf0076e74cab90a3 TEST_DIR/test-431/file
+5f4e111811dd9a810143c9db9bec6d80 TEST_DIR/test-431/copy
+Swap middle parts of original file
+md5sums after swapping middle:
+e11fbace556cba26bf0076e74cab90a3 TEST_DIR/test-431/file
+8c81889a5a50b311197110bcf769a695 TEST_DIR/test-431/copy
+Copy tail of original file onto copy
+md5sums after copying tail:
+e11fbace556cba26bf0076e74cab90a3 TEST_DIR/test-431/file
+e5fbacd993eaa5e80ebc2b14b969887d TEST_DIR/test-431/copy
diff --git a/tests/generic/group b/tests/generic/group
index b5f115af..608c45b2 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -433,3 +433,4 @@
428 auto quick
429 auto quick copy
430 auto quick copy
+431 auto quick copy
--
2.12.2
next prev parent reply other threads:[~2017-05-10 17:47 UTC|newest]
Thread overview: 10+ messages / expand[flat|nested] mbox.gz Atom feed top
2017-05-10 17:46 [PATCH v6 0/5] Add copy_file_range() tests Anna Schumaker
2017-05-10 17:46 ` [PATCH v6 1/5] generic/429: Add copy to new file test Anna Schumaker
2017-05-12 13:08 ` Eryu Guan
2017-05-10 17:46 ` [PATCH v6 2/5] generic/430: Add small copies " Anna Schumaker
2017-05-10 17:46 ` Anna Schumaker [this message]
2017-05-10 17:46 ` [PATCH v6 4/5] generic/432: Add a copy test for overwriting small amounts of data Anna Schumaker
2017-05-10 18:37 ` Darrick J. Wong
2017-05-10 18:39 ` Anna Schumaker
2017-05-11 7:27 ` Eryu Guan
2017-05-10 17:46 ` [PATCH v6 5/5] generic/433: Add a copy test for invalid input Anna Schumaker
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20170510174628.22895-4-Anna.Schumaker@Netapp.com \
--to=anna.schumaker@netapp.com \
--cc=fstests@vger.kernel.org \
--cc=hch@infradead.org \
--cc=linux-nfs@vger.kernel.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox